package com.jaworski.security.handbook;

import java.math.BigInteger;
import java.security.SecureRandom;

public class PrimeGeneration {
 public static void main(String[] args) {
  if(args.length != 2) {
   String err = "Usage: java ";
   err += "com.jaworski.security.handbook.PrimeGeneration ";
   err += "bitLength certainty";
   System.out.println(err);
   System.exit(0);
  }
  int arg = 0;
  try {
   int bitLength = (new Integer(args[0])).intValue();
   ++arg;
   int certainty = (new Integer(args[1])).intValue();
   SecureRandom rnd = new SecureRandom();
   BigInteger n = new BigInteger(bitLength,certainty,rnd);
   System.out.println(n); 
  }catch(NumberFormatException e) {
   String err = "Error: arg["+arg+"] is invalid.";
   System.out.println(err);
  }
 }
}