package com.jaworski.security.handbook;

import java.math.BigInteger;

public class PrimeTest {
 public static void main(String[] args) {
  if(args.length != 2) {
   String err = "Usage: java ";
   err += "com.jaworski.security.handbook.PrimeTest ";
   err += "certainty numberToBeTested";
   System.out.println(err);
   System.exit(0);
  }
  int arg = 0;
  try {
   int c = (new Integer(args[0])).intValue();
   ++arg;
   BigInteger n = new BigInteger(args[1]);
   boolean result = n.isProbablePrime(c);
   String resultString = ""+args[1]+" IS ";
   if(!result) resultString += "NOT ";
   resultString += "probably prime with certainty "+c+".";
   System.out.println(resultString); 
  }catch(NumberFormatException e) {
   String err = "Error: arg["+arg+"] is invalid.";
   System.out.println(err);
  }
 }
}
