package com.jaworski.security.handbook;

import java.io.*;
import java.security.*;
import javax.crypto.*;

public class BlowfishDecryptConsoleApp {
 public static void main(String[] args) {
  String help = "Usage: java com.jaworski.security.handbook.";
  help += "BlowfishDecryptConsoleApp ciphertextfile plaintextfile";
  if(args.length != 2) System.out.println(help);  
  else blowfishEncrypt(args[0],args[1]);
 }
 public static void blowfishEncrypt(String f1,String f2) {
  // Open the key file -- It must be in the current directory.
  SecretKey key = null;
  try {
   // Does a BlowfishKey.ser file exist?
   ObjectInputStream keyFile = new ObjectInputStream(
    new FileInputStream("BlowfishKey.ser"));
   key = (SecretKey) keyFile.readObject();
   keyFile.close();
  }catch(FileNotFoundException e) {
   // If not, report error and exit.
   System.out.println("Key file not found.");
   System.exit(0);
  }catch(Exception e) {
   System.out.println("Error reading key.");
   System.exit(0);  
  }
  // Create a cipher
  Cipher cipher = null;
  try {
   cipher = Cipher.getInstance("Blowfish/ECB/PKCS5Padding");
   cipher.init(Cipher.DECRYPT_MODE,key);
  }catch(InvalidKeyException e) {
   System.out.println("Key is invalid.");
   System.exit(0);   
  }catch(Exception e) {
   System.out.println("Error creating cipher.");
   System.exit(0);
  }
  // Read and decrypt file.
  try {
   CipherInputStream in = new CipherInputStream(
    new BufferedInputStream(new FileInputStream(f1)),
    cipher);
   BufferedOutputStream out = new BufferedOutputStream(
    new FileOutputStream(f2));
   int i;
   do {
    i = in.read();
    if(i != -1) out.write(i);
   } while(i>0);
   in.close();
   out.close();
  }catch(Exception e) {
   System.out.println(e);
   System.out.println("Error reading/decrypting.");
  }
 }
}