package com.jaworski.security.handbook;

// Support encryption using a LetterSubstitution object.
public class LetterCipher {
 // Encrypt a String object.
 public static String encrypt(String s, LetterSubstitution k) {
  String returnValue = "";
  for(int i=0;i<s.length();++i) {
   char c = s.charAt(i);
   c = encrypt(c,k);
   returnValue += String.valueOf(c);
  }
  return returnValue;
 }
 // Decrypt a String object.
 public static String decrypt(String s, LetterSubstitution k) {
  String returnValue = "";
  for(int i=0;i<s.length();++i) {
   char c = s.charAt(i);
   c = decrypt(c,k);
   returnValue += String.valueOf(c);
  }
  return returnValue;
 }
 // Encrypt a single character.
 public static char encrypt(char c, LetterSubstitution k) {
  return k.getSubstitute(c);
 }
 // Decrypt a single character.
 public static char decrypt(char c, LetterSubstitution k) {
  return k.getLetter(c);
 }
}
