package com.jaworski.security.handbook;

import java.security.*;
import javax.crypto.*;

public class SecureRandomApp { 
 public static void main(String[] args) 
   throws NoSuchAlgorithmException {
  if(args.length == 0) {
   String err = "Usage: com.jaworski.security.handbook";
   err += ".SecureRandomApp numBytes [seed]";
   System.out.println(err);
   System.exit(0);
  }
  // Converts args[0] to an int value
  int numBytes = (new Integer(args[0])).intValue();
  // Converts args[1] to a long value
  long seed = 0l;
  if(args.length > 1) seed = (new Long(args[1])).longValue();
  // Create a SecureRandom object
  SecureRandom srand = SecureRandom.getInstance("SHA1PRNG");
  // Seed it
  if(seed != 0l) srand.setSeed(seed);
  // Generate numBytes random bytes
  byte[] bytes = new byte[numBytes];
  srand.nextBytes(bytes);
  // Display the bytes
  String s = Conversion.byteArrayToBase64String(bytes);
  System.out.println(s);
 }
}
