package com.jaworski.security.handbook;

import java.security.*;
import java.io.*;

public class DigestStreamTestApp {
// SHA test suite from FIPS 180-1
static String testCase = 
 "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq";
static String expectedResult = 
 "84983e441c3bd26ebaae4aa1f95129e5e54670f1";

 public static void main(String[] args) {
  performOutputTest();
  performInputTest();
 }
 static void performOutputTest() {
  try {
   MessageDigest md = MessageDigest.getInstance("SHA");
   FileOutputStream fout = new FileOutputStream("sha-results.txt");
   DigestOutputStream out = new DigestOutputStream(fout,md);
   byte[] b = testCase.getBytes();
   out.write(b,0,b.length);
   md = out.getMessageDigest();
   String s = Conversion.byteArrayToHexString(md.digest());
   System.out.println("\nOutput test case: "+testCase);
   System.out.println("Expected result:    "+expectedResult);
   System.out.println("Calculated result:  "+s);
  }catch(Exception e) {
   System.out.println(e);
   System.exit(0);
  }
 }
 static void performInputTest() {
  try {
   MessageDigest md = MessageDigest.getInstance("SHA");
   FileInputStream fin = new FileInputStream("sha-results.txt");
   DigestInputStream in = new DigestInputStream(fin,md);
   byte[] b = new byte[testCase.length()];
   in.read(b,0,testCase.length());
   md = in.getMessageDigest();
   String s = Conversion.byteArrayToHexString(md.digest());
   System.out.println("\nInput test case: "+(new String(b)));
   System.out.println("Expected result:    "+expectedResult);
   System.out.println("Calculated result:  "+s);
  }catch(Exception e) {
   System.out.println(e);
   System.exit(0);
  }
 }
}
