package com.jaworski.security.handbook;

import java.security.*;
import javax.crypto.*;

public class MACApp {
 static String errorMessage = 
  "Usage: com.jaworski.security.handbook.MACApp testString";
 public static void main(String[] args) {
  if(args.length < 1) 
   System.out.println(errorMessage);
  else performMACTest(args[0]);
 }
 static void performMACTest(String s) {
  try {
   String alg = "HmacMD5";
   Mac mac = Mac.getInstance(alg);
   KeyGenerator kg = KeyGenerator.getInstance(alg);
   SecretKey key = kg.generateKey();
   mac.init(key);
   mac.update(s.getBytes());
   byte[] b = mac.doFinal();
   System.out.println("\nMessage: "+s);
   System.out.println("MAC:     "+
    Conversion.byteArrayToHexString((b)));
  }catch(Exception e) {
   System.out.println(e);
   System.exit(0);
  }
 }
}