package com.jaworski.security.handbook;

import java.security.*;

public class MessageDigestTestApp {
// MD5 test suite from RFC 1321
static String[] testCase = {"", "a", "abc", "message digest",
 "abcdefghijklmnopqrstuvwxyz", 
 "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
 "12345678901234567890123456789012345678901234567890123456789012345678901234567890"};
static String[] expectedResult = {"d41d8cd98f00b204e9800998ecf8427e",
 "0cc175b9c0f1b6a831c399e269772661",
 "900150983cd24fb0d6963f7d28e17f72",
 "f96b697d7cb7938d525a2f31aaf161d0",
 "c3fcd3d76192e4007dfb496cca67e13b",
 "d174ab98d277d9f5a5611c2c9f419d9f",
 "57edf4a22be3c955ac49da2e2107b67a"};

 public static void main(String[] args) {
  for(int i=0; i<testCase.length; ++i) 
   performMD5Test(i);
 }
 static void performMD5Test(int i) {
  try {
   MessageDigest md = MessageDigest.getInstance("MD5");
   md.update(testCase[i].getBytes());
   String s = Conversion.byteArrayToHexString(md.digest());
   System.out.println("\nTest case:         "+testCase[i]);
   System.out.println("Expected result:   "+expectedResult[i]);
   System.out.println("Calculated result: "+s);
  }catch(NoSuchAlgorithmException e) {
   System.out.println("MD5 is not supported.");
   System.exit(0);
  }
 }
}
