package com.jaworski.security.handbook;

import java.security.*;
import javax.crypto.*;

public final class ProviderTest {
 String providerName = "Rot13Provider";
 String algorithmName ="ROT13";
 public static void main(String[] args) {
  listProviderInfo();
  testCipher();
 }
 static void listProviderInfo() {
  Provider p = Security.getProvider("Rot13Provider");
  System.out.println("Provider name: " + p.getName());
  System.out.println("Provider version: " + p.getVersion());
  System.out.println("Provider information: " + p.getInfo());
 }
 static void testCipher() {
  try {
   Cipher cipher = Cipher.getInstance("ROT13", "Rot13Provider");
   System.out.println("Cipher: " + cipher.getAlgorithm());
   String testString = "This is a test!";
   cipher.init(Cipher.ENCRYPT_MODE,null,new SecureRandom());
   byte[] b1 = cipher.doFinal(testString.getBytes());
   cipher.init(Cipher.DECRYPT_MODE,null,new SecureRandom());
   byte[] b2 = cipher.doFinal(b1);
   System.out.println("Data to be encrypted: " + testString);
   System.out.println("Encrypted data: " + 
    Conversion.byteArrayToHexString(b1));
   System.out.println("Decrypted data: " + 
    Conversion.byteArrayToHexString(b2));
   System.out.println("Decrypted data as a String: " + new String(b2));
  }catch(Exception e) {
   e.printStackTrace();
   System.exit(0);
  } 
 }
}
