import java.sql.*;
import java.util.*;

class StatementApp {
 public static void main(String args[]) {
  if(args.length!=1){
   System.out.println("Usage: java StatementApp sql");
   System.exit(0);
  }
  try{
   // Load IDS driver
   Class.forName("ids.sql.IDSDriver");
   String url="jdbc:ids://cx122974-a.cv1.sdca.home.com:80/";
   url+="conn?dbtype=odbc&dsn='IDSExamples'";
   // Connect to database
   Connection connection=DriverManager.getConnection(url);
   Statement statement = connection.createStatement();
   String sql=args[0];
   System.out.println(sql);
   // Execute SQL statement
   boolean hasResults = statement.execute(sql);
   if(hasResults){
    // Retrieve result set
    ResultSet result = statement.getResultSet();
    if(result!=null) displayResults(result);
   }
   // Close database connection
   connection.close();
  }catch(Exception ex){
   System.out.println(ex);
   System.exit(0);
  }
 }
 static void displayResults(ResultSet r) throws SQLException {
  // Get meta data about result set
  ResultSetMetaData rmeta = r.getMetaData();
  // Use meta data to determine the number of columns
  // in the result set
  int numColumns=rmeta.getColumnCount();
  // Display values of each column
  for(int i=1;i<=numColumns;++i) {
   if(i<numColumns)
    System.out.print(rmeta.getColumnName(i)+" | ");
   else
    System.out.println(rmeta.getColumnName(i));
  }
  while(r.next()){
   for(int i=1;i<=numColumns;++i) {
    if(i<numColumns)
     System.out.print(r.getString(i)+" | ");
    else
     System.out.println(r.getString(i).trim());
   }
  }
 }
}
